﻿using System;
using System.Windows.Forms;

namespace FindCenterOfCircle
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }
             
        void calc()
        {
            double x1 = System.Convert.ToDouble(numericUpDown1.Value);
            double y1 = System.Convert.ToDouble(numericUpDown2.Value);
            double x2 = System.Convert.ToDouble(numericUpDown3.Value);
            double y2 = System.Convert.ToDouble(numericUpDown4.Value);
            double x3 = System.Convert.ToDouble(numericUpDown5.Value);
            double y3 = System.Convert.ToDouble(numericUpDown6.Value);

            textBox1.Text = "--";
            textBox2.Text = "--";
            textBox3.Text = "--";

            if ((y1 != y2) && (y1 != y3))
            {
                double d = (x2 - x1) / (y1 - y2);
                double e = (x1 * x1 - x2 * x2 + y1 * y1 - y2 * y2) / (2 * (y1 - y2));
                double f = (x3 - x1) / (y1 - y3);
                double g = (x1 * x1 - x3 * x3 + y1 * y1 - y3 * y3) / (2 * (y1 - y3));

                if (d != f)
                {
                    double x = (g - e) / (d - f);
                    double y = x * d + e;
                    double r = Math.Sqrt(Math.Pow(x - x1, 2) + Math.Pow(y - y1, 2));

                    var InvC = System.Globalization.CultureInfo.InvariantCulture;
                    textBox1.Text = x.ToString("F2", InvC);
                    textBox2.Text = y.ToString("F2", InvC);
                    textBox3.Text = r.ToString("F2", InvC);
                }                
            }                   
        }

        private void numericUpDown1_ValueChanged(object sender, EventArgs e)
        {
            calc();
        }

        private void numericUpDown4_ValueChanged(object sender, EventArgs e)
        {
            calc();
        }

        private void numericUpDown6_ValueChanged(object sender, EventArgs e)
        {
            calc();
        }

        private void numericUpDown2_ValueChanged(object sender, EventArgs e)
        {
            calc();
        }

        private void numericUpDown3_ValueChanged(object sender, EventArgs e)
        {
            calc();
        }

        private void numericUpDown5_ValueChanged(object sender, EventArgs e)
        {
            calc();
        }

        private void Form1_Shown(object sender, EventArgs e)
        {
            calc();
        }
    }
}
